#!/usr/bin/env python3

import sys
from ucb import main
from mr import values_by_key, emit

@main
def run(k):
    k = int(k)
    for key, value_iterator in values_by_key(sys.stdin):
        counts = {}
        for value in value_iterator:
            counts[value] = 1 + counts.get(value, 0)
        values = sorted(counts.items(), key=lambda item: -item[1])
        emit(key, tuple(v[0] for v in values[:min(len(values), k)]))
